export default function initiate(config) {
    var tray = 0;
    var card = 0;
    var scrollX = 0,
        scrollY = 0;
    var traycard = [];
    let eventNavHandle = {
        up: "ArrowUp",
        down: "ArrowDown",
        right: "ArrowRight",
        left: "ArrowLeft"
    };
    if (config.event == "keypress") {
        eventNavHandle = {
            up: "8",
            down: "2",
            right: "6",
            left: "4"
        };
    }
    document
        .body
        .addEventListener(config.event, (event) => {
            event.preventDefault();
            switch (event.key) {
                case eventNavHandle.down:
                    if (!checkDefault()) {
                        if (tray < document.getElementsByClassName(config.tray).length - 1) {
                            card = 0;
                            scrollX = 0; //selecting first card of the tray
                            tray += 1;
                            scrollY += 200; // moving to next tray
                        }
                        changeValues();
                    } else {
                        traycard[tray] = traycard['tray'] = 0; // to keep track of corresponding tray's previously selected card // setting to zero since selecting default
                    }
                    break;
                case eventNavHandle.left:
                    if (!checkDefault()) {
                        if (card) {
                            card -= 1; // card width as scrollX, moving one card left
                        }
                        changeValues();
                    } else {
                        traycard[tray] = traycard['tray'] = 0;
                    }
                    break;
                case eventNavHandle.right:
                    if (!checkDefault()) {
                        let trayTemp = document.getElementsByClassName(config.tray)[tray];
                        if (trayTemp && card < trayTemp.getElementsByClassName(config.card).length) {
                            card += 1;
                        }
                        changeValues();
                    } else {
                        traycard[tray] = traycard['tray'] = 0;
                    }
                    break;
                case eventNavHandle.up:
                    if (!checkDefault()) {
                        if (tray > 0) {
                            card = 0;
                            scrollX = 0;
                            tray -= 1;
                            scrollY -= 200;
                        }
                        changeValues();
                    } else {
                        traycard[tray] = traycard['tray'] = 0;
                    }
                    break;
                case "5":
                    if (!checkDefault()) {}
                    config.callBack();
                    break;

                default:
                    if (!checkDefault()) {}
                    break;
            }
        });

    function changeValues() {
        if (traycard['tray'] != tray && traycard[tray]) { // if the tray have already selected card, use that card number
            card = traycard[tray];
        }
        selectCard(tray, card, scrollX, scrollY);
        traycard[tray] = card;
        traycard['tray'] = tray;
    }

    function checkDefault() {
        if (!document.getElementsByClassName(config.selectedCard).length) {
            var fcomp = document.getElementsByClassName(config.tray)[0];
            var sComp = fcomp.getElementsByClassName(config.card)[0];
            sComp.className = config.selectedCard;
            return true;
        } else {
            return false;
        }
    }

    function selectCard(tray, card, scrollX, scrollY) {
        var sCard = document.getElementsByClassName(config.selectedCard)[0];
        sCard.className = config.card;
        var fcomp = document.getElementsByClassName(config.tray)[tray];
        var sComp = fcomp.getElementsByClassName(config.card)[card];
        sComp.className = config.selectedCard;
        moveFocus(tray, card, scrollX, scrollY);
    }

    function moveFocus(tray, card, scrollX, scrollY, margin = 10, verticalScroll = true, defSelectCard = config.cardPosition - 2) {
        var fComp = document.getElementsByClassName(config.tray)[tray]; //Fetching tray
        var sComp = fComp.getElementsByClassName(config.card); // fetching cards from that tray
        var sCard = card < sComp.length
            ? sComp[card]
            : sComp[card - 1];
        if (card > 0 && sCard && sCard.offsetWidth) {
            scrollX = ((card - defSelectCard) * (sCard.offsetWidth + margin) - (sCard.offsetWidth + margin));
        } else if (sCard && sCard.offsetWidth) {
            scrollX = ((card - defSelectCard) * (sCard.offsetWidth + margin));
        }
        if ((card - 1) < sComp.length) {
            fComp.scrollTo(scrollX, scrollY);
        }
        if (tray > 0) {
            scrollY = scrollY + (tray * margin);
        } else {
            scrollY = scrollY;
        }
        if (config.verticleScroll) {
            window.scrollTo(scrollX, scrollY);
        }
    }
}
